Main Page Modules Namespace List Class Hierarchy Alphabetical List Compound List File List Namespace Members Compound Members File Members Related Pages

# deBitmap Class Reference

`#include <deBitmap_priv.hpp>`

Inheritance diagram for deBitmap:

[legend]
Collaboration diagram for deBitmap:

[legend]
List of all members.

## Public Member Functions
| deBitmap ()
| deBitmap (const char *filename)
void * | GetRscInterface (long interface_id)
deBoolean | LoadBMPFile (IdeFile *file)
deBoolean | LoadTGAFile (IdeFile *file)
deBoolean | LoadPCXFile (IdeFile *file)
deBoolean | LoadPNGFile (IdeFile *file)
deBoolean | LoadDDSFile (IdeFile *file)
deBoolean | LoadCMAPFile (IdeFile *file, const char *filename)
deBoolean | Reset ()
void | Cleanup ()
void * | GetData (u32 FaceNum)
| get the raw data contained in the bitmap
long | GetWidth ()
| get the width of this bitmap
long | GetHeight ()
| get the height of this bitmap
IdeDriver::BPP | GetFormat ()
| get the pixelformat of this bitmap
long | GetBitDepth ()
| get the bitdepth of this bitmap (multiple of 8 almost always)
long | GetByteDepth ()
| get the byte depth of this bitmap
DWORD | GetImageSize ()
| get the total amount of memory consumed by this bitmap
long | GetNumFaces ()
deBoolean | IsRenderTarget ()
| get whether or not this bitmap is used as a render target
long | GetScalingFactor ()
deARGB | GetColorAt (long X, long Y)
| get the color of a certain pixel, given pixel coordinates (returns ARGB format)
void | GetFloatColorAt (long X, long Y, deColor &color)
| get the color of a certain pixel, given pixel coordinates (using deColor format)
long | GetMipLevels ()
| retrieve the number of mip levels for this bitmap
deBoolean | SetData (void *data, long ByteLength, u32 FaceNum)
void | SetWidth (long width)
void | SetHeight (long height)
void | SetFormat (IdeDriver::BPP Format)
void | SetImageSize (long size)
void | SetRenderTarget (deBoolean RenderTarget)
void | SetColorAt (long X, long Y, deARGB Color)
void | SetColorAt (long X, long Y, const deColor &color)
deBoolean | SetNumFaces (long NumFaces)
void | SetMipLevels (long MipLevels)
deBoolean | CopyRect (const IdeBitmap *&Source, deRect *SourceRect, long TargetX, long TargetY)
deBoolean | SaveToFileSystem (IdeFileSystem *FS, const char *filename)
deBoolean | SaveToFile (IdeFile *file)
| only saves to a BMP file
void * | GetDriverData (long ID)
deBoolean | SetDriverData (long ID, void *Data, IdeDriver *Driver)
deBoolean | ConvertGrayScaleToDot3 (long numsamples, deFloat amplify)
| convert this grayscale bitmap into a 32-bit DOT3 bitmap
deBoolean | BindGrayScaleAsAlphaMap (IdeBitmap *AlphaMap)
| use another bitmap (same height & width) to fill in the alpha channel in this one
deBoolean | DownSampleMIP (void *&source, void *target, long SW, long SH, long SP, long TW, long TH, long TP, IdeDriver::BPP SFormat, IdeDriver::BPP TFormat)
IdeResourceBase * | MakeCopy ()
| create a copy of the object in memory
## Static Public Attributes
long | s_BitmapRscInterfaceID = 0
## Protected Member Functions
virtual | ~deBitmap ()
void | SetBitDepth (long depth)
long | WrappedIndex (long X, long Y)
long | WrappedIndex (long X, long Y, long Width, long Height)
deBoolean | DownSampleDXTC (void *&source, void *target, long SP, long SW, long SH, long TP, long TH, IdeDriver::BPP SFormat, IdeDriver::BPP TFormat)
## Protected Attributes
deTArray< u8 * > | m_Data
IdeDriver::BPP | m_Format
long | m_Width
long | m_Height
long | m_ByteDepth
long | m_ImageSize
long | m_MipLevels
deBoolean | m_RenderTarget
deTList< DriverBitmapEntry > | m_DriverData
## Friends
IdeBitmap * | IdeBitmap_CreateBitmapWithInfo (long Width, long Height, IdeDriver::BPP Format)
long | BPPByteDepth (IdeDriver::BPP BPPType)

## Constructor & Destructor Documentation

deBitmap::deBitmap | ( |  | ) |

deBitmap::deBitmap | ( | const char * | filename | ) |

deBitmap::~deBitmap | ( |  | ) | `[protected, virtual]`

## Member Function Documentation

deBoolean deBitmap::BindGrayScaleAsAlphaMap | ( | IdeBitmap * | AlphaMap | ) | `[virtual]`

| use another bitmap (same height & width) to fill in the alpha channel in this one Implements IdeBitmap.

void deBitmap::Cleanup | ( |  | ) | `[virtual]`

| Implements IdeBitmap.

deBoolean deBitmap::ConvertGrayScaleToDot3 | ( | long | numsamples,
|  | deFloat | amplify
| ) | `[virtual]`

| convert this grayscale bitmap into a 32-bit DOT3 bitmap Implements IdeBitmap.

deBoolean deBitmap::CopyRect | ( | const IdeBitmap *& | Source,
|  | deRect * | SourceRect,
|  | long | TargetX,
|  | long | TargetY
| ) | `[virtual]`

| Blitting function. Blits a source bitmap into this bitmap, clamping the edges. Source bitmap must share the same pixel format as this target. Implements IdeBitmap.

deBoolean deBitmap::DownSampleDXTC | ( | void *& | source,
|  | void * | target,
|  | long | SP,
|  | long | SW,
|  | long | SH,
|  | long | TP,
|  | long | TH,
|  | IdeDriver::BPP | SFormat,
|  | IdeDriver::BPP | TFormat
| ) | `[protected]`

deBoolean deBitmap::DownSampleMIP | ( | void *& | source,
|  | void * | target,
|  | long | SW,
|  | long | SH,
|  | long | SP,
|  | long | TW,
|  | long | TH,
|  | long | TP,
|  | IdeDriver::BPP | SFormat,
|  | IdeDriver::BPP | TFormat
| ) | `[virtual]`

| Implements IdeBitmap.

long deBitmap::GetBitDepth | ( |  | ) | `[virtual]`

| get the bitdepth of this bitmap (multiple of 8 almost always) Implements IdeBitmap.

long deBitmap::GetByteDepth | ( |  | ) | `[virtual]`

| get the byte depth of this bitmap Implements IdeBitmap.

deARGB deBitmap::GetColorAt | ( | long | X,
|  | long | Y
| ) | `[virtual]`

| get the color of a certain pixel, given pixel coordinates (returns ARGB format) Implements IdeBitmap.

void * deBitmap::GetData | ( | u32 | FaceNum | ) | `[virtual]`

| get the raw data contained in the bitmap Implements IdeBitmap.

void * deBitmap::GetDriverData | ( | long | ID | ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::GetFloatColorAt | ( | long | X,
|  | long | Y,
|  | deColor & | color
| ) | `[virtual]`

| get the color of a certain pixel, given pixel coordinates (using deColor format) Implements IdeBitmap.

IdeDriver::BPP deBitmap::GetFormat | ( |  | ) | `[virtual]`

| get the pixelformat of this bitmap Implements IdeBitmap.

long deBitmap::GetHeight | ( |  | ) | `[virtual]`

| get the height of this bitmap Implements IdeBitmap.

DWORD deBitmap::GetImageSize | ( |  | ) | `[virtual]`

| get the total amount of memory consumed by this bitmap Implements IdeBitmap.

long deBitmap::GetMipLevels | ( |  | ) | `[virtual]`

| retrieve the number of mip levels for this bitmap Implements IdeBitmap.

long deBitmap::GetNumFaces | ( |  | ) | `[virtual]`

| Implements IdeBitmap.

void * deBitmap::GetRscInterface | ( | long | interface_id | ) | `[virtual]`

  | Used to retrieve a pointer to an interface registered through IdeResourceManager. Returns: NULL or a valid pointer to an interface supported by this object Parameters:
  interface_id | A value previously retrieved through IdeResourceManager::GetUniqueInterfaceID
Reimplemented from deResourceBase.

long deBitmap::GetScalingFactor | ( |  | ) | `[virtual]`

| Implements IdeBitmap.

long deBitmap::GetWidth | ( |  | ) | `[virtual]`

| get the width of this bitmap Implements IdeBitmap.

deBoolean deBitmap::IsRenderTarget | ( |  | ) | `[virtual]`

| get whether or not this bitmap is used as a render target Implements IdeBitmap.

deBoolean deBitmap::LoadBMPFile | ( | IdeFile * | file | ) |

deBoolean deBitmap::LoadCMAPFile | ( | IdeFile * | file,
|  | const char * | filename
| ) |

deBoolean deBitmap::LoadDDSFile | ( | IdeFile * | file | ) |

deBoolean deBitmap::LoadPCXFile | ( | IdeFile * | file | ) |

deBoolean deBitmap::LoadPNGFile | ( | IdeFile * | file | ) |

deBoolean deBitmap::LoadTGAFile | ( | IdeFile * | file | ) |

IdeResourceBase * deBitmap::MakeCopy | ( |  | ) | `[virtual]`

| create a copy of the object in memory Implements deResourceBase.

deBoolean deBitmap::Reset | ( |  | ) | `[virtual]`

| Implements IdeBitmap.

deBoolean deBitmap::SaveToFile | ( | IdeFile * | file | ) | `[virtual]`

| only saves to a BMP file Implements IdeBitmap.

deBoolean deBitmap::SaveToFileSystem | ( | IdeFileSystem * | FS,
|  | const char * | filename
| ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetBitDepth | ( | long | depth | ) | `[protected, virtual]`

| Implements IdeBitmap.

void deBitmap::SetColorAt | ( | long | X,
|  | long | Y,
|  | const deColor & | color
| ) |

void deBitmap::SetColorAt | ( | long | X,
|  | long | Y,
|  | deARGB | Color
| ) | `[virtual]`

| Implements IdeBitmap.

deBoolean deBitmap::SetData | ( | void * | data,
|  | long | ByteLength,
|  | u32 | FaceNum
| ) | `[virtual]`

| Implements IdeBitmap.

deBoolean deBitmap::SetDriverData | ( | long | ID,
|  | void * | Data,
|  | IdeDriver * | Driver
| ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetFormat | ( | IdeDriver::BPP | Format | ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetHeight | ( | long | height | ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetImageSize | ( | long | size | ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetMipLevels | ( | long | MipLevels | ) | `[virtual]`

| Implements IdeBitmap.

deBoolean deBitmap::SetNumFaces | ( | long | NumFaces | ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetRenderTarget | ( | deBoolean | RenderTarget | ) | `[virtual]`

| Implements IdeBitmap.

void deBitmap::SetWidth | ( | long | width | ) | `[virtual]`

| Implements IdeBitmap.

long deBitmap::WrappedIndex | ( | long | X,
|  | long | Y,
|  | long | Width,
|  | long | Height
| ) | `[protected]`

long deBitmap::WrappedIndex | ( | long | X,
|  | long | Y
| ) | `[protected]`

## Friends And Related Function Documentation

long BPPByteDepth | ( | IdeDriver::BPP | BPPType | ) | `[friend]`

IdeBitmap* IdeBitmap_CreateBitmapWithInfo | ( | long | Width,
|  | long | Height,
|  | IdeDriver::BPP | Format
| ) | `[friend]`

## Member Data Documentation

long deBitmap::m_ByteDepth`[protected]`

deTArray<u8*> deBitmap::m_Data`[protected]`

deTList<DriverBitmapEntry> deBitmap::m_DriverData`[protected]`

IdeDriver::BPP deBitmap::m_Format`[protected]`

long deBitmap::m_Height`[protected]`

long deBitmap::m_ImageSize`[protected]`

long deBitmap::m_MipLevels`[protected]`

deBoolean deBitmap::m_RenderTarget`[protected]`

long deBitmap::m_Width`[protected]`

long deBitmap::s_BitmapRscInterfaceID = 0`[static]`

The documentation for this class was generated from the following files:

- deBitmap_priv.hpp
- deBitmap.cpp
- deBitmapLoad.cpp